<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'SolutionsCards',
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
});
</script>

<template>
  <section
    :id="data?.id"
    class="solutions-cards-wrapper"
    :class="`solutions-cards-wrapper--${data.layout}`"
  >
    <SlpContainer>
      <SlpRow>
        <div class="solutions-cards__header slp-mb-48">
          <SlpTypography tag="h2" variant="heading2-bold" class="header">
            {{ data.title || 'Resources' }}</SlpTypography
          >
          <SlpButton
            v-if="data.link"
            :href="data.link.url"
            variant="tertiary"
            class="slp-mt-32 cta-button"
            :aria-label="data.link.data_ga_name"
            :data-ga-name="data.link.data_ga_name"
            :data-ga-location="data.link.data_ga_location"
            >{{ data.link.text || $t('resources') }}
            <SlpIcon name="chevron-lg-right" variant="product" />
          </SlpButton>
        </div>

        <SlpRow class="resources-container">
          <SlpColumn
            v-for="(card, index) in data.cards"
            :key="index"
            :cols="data.column_size"
            :data-aos="data.cards_animation"
            :data-aos-duration="data.cards_animation_duration"
          >
            <div :href="card.href" class="solutions-cards">
              <div class="solutions-cards__wrapper">
                <div class="solutions-cards__content-top">
                  <div class="solutions-cards__category slp-flex">
                    <SlpIcon
                      v-if="card.icon"
                      :name="card.icon.name"
                      :alt="card.icon.alt"
                      :variant="card.icon.variant"
                      size="md"
                    />
                    <SlpTypography tag="p" variant="body"
                      >{{ card.category }}
                    </SlpTypography>
                  </div>
                  <SlpTypography
                    tag="h3"
                    variant="heading5-bold"
                    class="solutions-cards__title"
                    >{{ card.title }}
                  </SlpTypography>
                  <SlpTypography
                    tag="p"
                    variant="body1"
                    class="solutions-cards__description"
                    ><span v-html="card.description"></span>
                  </SlpTypography>
                  <SlpButton
                    variant="tertiary"
                    class="learn-more"
                    :href="card.href"
                    :data-ga-name="card?.data_ga_name"
                    :data-ga-location="card?.data_ga_location"
                    >{{ card.cta || $t('learnMore') }}

                    <SlpIcon name="chevron-lg-right" variant="product" />
                  </SlpButton>
                  <ul v-if="card.list" class="solutions-cards__list">
                    <li
                      v-for="feature in card.list"
                      :key="feature.text"
                      class="item"
                    >
                      <SlpIcon
                        name="check"
                        class="bullet"
                        variant="product"
                        alt="Check icon"
                        size="sm"
                      />
                      <span class="slp-text-body1" v-html="feature.text"></span>
                    </li>
                  </ul>
                </div>
              </div>
            </div>
          </SlpColumn>
        </SlpRow>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.solutions-cards-wrapper {
  background-color: $color-surface-800;
  padding: $spacing-96 0;
  position: relative;
  .learn-more {
    padding-left: 0;
  }
  @media (max-width: $breakpoint-md) {
    padding: $spacing-48 0;
  }

  .header {
    width: 60%;
    @media (max-width: $breakpoint-lg) {
      width: 100%;
    }
  }

  &--light {
    background: $color-surface-50;
    transition: all 0.3s ease-in-out;

    .solutions-cards__wrapper:hover {
      background: $color-surface-800;
      border-bottom-right-radius: 100px;
    }
  }

  .solutions-cards {
    //cursor: pointer;
    display: flex;
    position: relative;
    height: 100%;

    &__wrapper {
      display: flex;
      flex-direction: column;
      transition: all 0.3s ease-in-out;
      justify-content: space-between;
      padding: $spacing-16;
      background: $color-primary-300;
      flex: 1;
      border-radius: $spacing-4;
      @media (min-width: $breakpoint-md) {
        margin: $spacing-8 $spacing-16 $spacing-8 0;
      }
      @media (max-width: $breakpoint-md) {
        margin: $spacing-8 0;
      }
    }

    &__header {
      width: 100%;
      display: flex;
      flex-direction: row;
      justify-content: space-between;
      align-items: center;
      @media (max-width: $breakpoint-lg) {
        flex-wrap: wrap;
      }
    }

    &__category {
      margin-bottom: $spacing-24;

      img {
        max-width: 30px;
        filter: grayscale(100%);
        -webkit-filter: grayscale(100%);
      }

      p {
        margin-left: $spacing-8;
      }
    }

    &__image {
      max-width: 100%;
    }

    &__link {
      color: $color-text-300;
      padding-left: 0;
    }

    &__title {
      margin-bottom: $spacing-16;
    }

    &__description {
      margin-bottom: $spacing-16;
    }

    &__list {
      margin-bottom: $spacing-16;

      .item {
        margin-bottom: $spacing-16;
        display: flex;
      }

      .bullet {
        margin-right: $spacing-8;
      }
    }

    &__content-top {
      display: flex;
      flex-basis: 100%;
      flex-direction: column;
      justify-content: space-between;
      p,
      h3,
      li {
        color: $color-text-300;
      }

      :last-child {
        margin-bottom: 0;
      }
    }
  }
  .cta-button {
    align-self: flex-end;
    @media (max-width: $breakpoint-lg) {
      width: 100%;
      padding: 0;
      margin-top: $spacing-48;
    }
  }
}
</style>
